<?xml version='1.0'?>
<!-- 
	$Id$
	Copyright (C) Authors contributing to this file.
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/
	
	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.
	
	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version='1.0'>
	<xsl:import href="../docbook/xsl/html/docbook.xsl" />
	<xsl:param name="admon.style"></xsl:param>

	<xsl:output method="xml" doctype-system="helpfile.dtd" indent="yes" encoding="UTF-8" />

	<xsl:template match="/">
		<xsl:comment>
"Copyright (C) Authors contributing to this file.

This file is part of BASE - BioArray Software Environment. Available at
http://base.thep.lu.se/

BASE is free software; you can redistribute it and/or modify it under the terms of the
GNU General Public License as published by the Free Software Foundation; either version
2 of the License, or (at your option) any later version.

BASE is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite
		</xsl:comment>
		<xsl:element name="helptexts">
			<xsl:attribute name="clientExternalID">net.sf.basedb.clients.web</xsl:attribute>
			<xsl:for-each select="//helptext">
				<xsl:element name="helpitem">
					<xsl:attribute name="externalID">
						<xsl:value-of select="@external_id" />
					</xsl:attribute>
					<xsl:element name="name">
						<xsl:value-of select="@title" />
					</xsl:element>
					<xsl:element name="description">
							<xsl:apply-templates select="*"/>
					</xsl:element>
				</xsl:element>
			</xsl:for-each>
		</xsl:element>
	</xsl:template>

	<!--  skip text marked with <nohelp> tag -->
	<xsl:template match="nohelp">
	</xsl:template>

	<xsl:template match="seeother">
		<h4>See also</h4>
		<ul>
			<xsl:for-each select="other">
			<li>{@link <xsl:value-of select="@external_id" /><xsl:text> </xsl:text><xsl:value-of select="." />}</li>
			</xsl:for-each>
		</ul>
	</xsl:template>

	<xsl:template match="guibutton">
		<btn><xsl:apply-templates /></btn>
	</xsl:template>

	<xsl:template match="guilabel">
		<lbl><xsl:apply-templates /></lbl>
	</xsl:template>

</xsl:stylesheet>