/*
	$Id $

	Copyright (C) 2005 Samuel Andersson, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.Date;

/**
	Adds the date an item was registered in the database. Since this is a new
	interface in BASE 2.10 pre-existing items doesn't have this information.
	
	@author Nicklas
	@version 2.10
	@see net.sf.basedb.core.BasicBatcher
	@see <a href="../../../../../../html/developerdoc/api/data_api.basic.html">Basic classes and interfaces</a>
*/
public interface RegisteredData
	extends IdentifiableData
{
	/**
		Get the date this item was added to the database. The value is
		generated at creation time and can't be modified later.
		@hibernate.property column="`entry_date`" type="date" not-null="false" update="false"
		@since 2.10
	*/
	public Date getEntryDate();

}
