/**
	$Id: ExportableField.java 4925 2009-05-08 11:30:36Z nicklas $

	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.export.spotdata;

import net.sf.basedb.util.formatter.Formatter;

/**
	Interface that represents an exportable field.
	

	@author Nicklas
	@version 2.12
	@base.modified $Date: 2009-05-08 13:30:36 +0200 (Fri, 08 May 2009) $
*/
public interface ExportableField
{

	/**
		Get the column header.
	*/
	public String getTitle();

	/**
		Get a formatter that converts the values in this field to strings.
		@return A formatter or null to use default formatting (normally this means
			calling the toString() method).
	*/
	public Formatter<?> getFormatter();
	
}
