<%-- $Id: edit_plugintype.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginType"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PLUGINTYPE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	PluginType pluginType = null;

	if (itemId == 0)
	{
		title = "Create plugin type";
		cc.removeObject("item");
	}
	else
	{
		pluginType = PluginType.getById(dc, itemId);
		cc.setObject("item", pluginType);
		title = "Edit plugin type -- " + HTML.encodeTags(pluginType.getName());
	}
	if (pluginType != null && !pluginType.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "PluginType" tab
		function validatePluginType()
		{
			var frm = document.forms['pluginType'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (Main.trimString(frm.interfaceName.value) == '')
			{
				alert("You must enter an interface name");
				frm.interfaceName.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['pluginType'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (pluginType == null)
			{
				%>
				var frm = document.forms['pluginType'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="pluginType" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*220)+"px;"%>" 
			position="bottom" remember="<%=pluginType != null%>">
		<t:tab id="info" title="Plugin type" validate="validatePluginType()" helpid="plugintype.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(pluginType == null ? 
						Values.getString(cc.getPropertyValue("name"), "New plugin type") : pluginType.getName())%>" 
					size="60" maxlength="<%=PluginType.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Interface</td>
				<td><input <%=requiredClazz%> type="text" name="interfaceName" 
					value="<%=HTML.encodeTags(pluginType == null ? cc.getPropertyValue("interfaceName") : pluginType.getInterfaceName())%>" 
					size="60" maxlength="<%=PluginType.MAX_INTERFACENAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Jar path</td>
				<td><input <%=clazz%> type="text" name="jarPath" 
					value="<%=HTML.encodeTags(pluginType == null ? cc.getPropertyValue("jarPath") : pluginType.getJarPath())%>" 
					size="60" maxlength="<%=PluginType.MAX_JARPATH_LENGTH%>"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="50" name="description" wrap="virtual"
						><%=HTML.encodeTags(pluginType == null ? cc.getPropertyValue("description") : pluginType.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'pluginType', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
