<%-- $Id: broadcast.jsp 4567 2008-10-07 12:13:53Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ClientDefaultSetting"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

try
{
	final Client server = Client.getById(dc, sc.getClientId());
	final boolean writePermission = server.hasPermission(Permission.WRITE);
	
	String title = (String)application.getAttribute("broadcast.title");
	String message = (String)application.getAttribute("broadcast.message");
	Boolean denyLogin = (Boolean)application.getAttribute("broadcast.deny-login");
	%>
	<base:page type="popup" title="Broadcast message">
	<base:head>
	<script language="JavaScript">
	// Submit the form
	function saveSettings()
	{
		var frm = document.forms["broadcast"];
		frm.submit();
	}
	function clearMessage()
	{
		var frm = document.forms["broadcast"];
		frm.denyLogin.checked = false;
		frm.title.value = '';
		frm.message.value = '';
	}
	function init()
	{
		var frm = document.forms["broadcast"];
		frm.title.focus();		
	}
	</script>

	</base:head>
	<base:body onload="init()">
		<form name="broadcast" action="submit_server.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="SetBroadcastMessage">
	
		<h3 class="docked">Broadcast message <base:help helpid="broadcast.message"/></h3>
		<div class="boxedbottom">
		<%
		if (!writePermission)
		{
			%>
			<div class="error">You do not have permission to broadcast messages to users.</div>
			<%
		}
		else
		{
			%>
			<table class="form">
			<tr>
				<td class="prompt">Title</td>
				<td>
					<input class="text" 
						type="text" name="title" value="<%=HTML.encodeTags(title)%>" size="60" maxlength="255">
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Disable login</td>
				<td>
					<input type="checkbox" name="denyLogin" <%=Boolean.TRUE.equals(denyLogin) ? "checked": ""%> value="1">
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Message</td>
				<td>
					<textarea class="text" rows="15" cols="60" name="message" wrap="virtual"><%=HTML.encodeTags(message)%></textarea>
					<a href="javascript:Main.zoom('Message', 'broadcast', 'message')" title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<%
		}
		%>
		</div>

		</form>
		<base:buttongroup align="center">
			<base:button onclick="clearMessage()" image="remove.png" title="Clear message" />
			<base:button onclick="saveSettings();" title="Ok" visible="<%=writePermission%>"/>
			<base:button onclick="window.close();" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

