<%-- $Id: edit_biosource.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioSource"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.BIOSOURCE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioSource bioSource = null;

	if (itemId == 0)
	{
		title = "Create biosource";
		cc.removeObject("item");
	}
	else
	{
		bioSource = BioSource.getById(dc, itemId);
		cc.setObject("item", bioSource);
		title = "Edit biosource -- " + HTML.encodeTags(bioSource.getName());
	}
	if (bioSource != null && !bioSource.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "BioSource" tab
		function validateBioSource()
		{
			var frm = document.forms['biosource'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['biosource'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
					annotationsLoaded = true;
				}
			}
		}

		function init()
		{
			<%
			if (bioSource == null)
			{
				%>
				var frm = document.forms['biosource'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="biosource" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=bioSource != null%>"switch="switchTab">
		<t:tab id="info" title="Biosource" validate="validateBioSource()" helpid="biosource.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(bioSource == null ? Values.getString(cc.getPropertyValue("name"), "New biosource") : bioSource.getName())%>" 
					size="40" maxlength="<%=BioSource.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(bioSource == null ? Values.getString(cc.getPropertyValue("externalId"), "") : bioSource.getExternalId())%>" 
					size="40" maxlength="<%=BioSource.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(bioSource == null ? cc.getPropertyValue("description") : bioSource.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'biosource', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
