<%-- $Id: list_files.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.PlatformFileType"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.FileSet"
	import="net.sf.basedb.core.FileSetMember"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileStoreEnabled"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.NameableComparator"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.HashMap"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Collection"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!

private static class DataFile
{
	final DataFileType type;
	final FileSetMember member;
	final FileStoreEnabled parent;
	DataFile(DataFileType type, FileSetMember member, FileStoreEnabled parent)
	{
		this.type = type;
		this.member = member;
		this.parent = parent;
	}
}

%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
final ItemContext cc = sc.getCurrentContext(itemType);
final String root = request.getContextPath() + "/";

try
{
	final FileStoreEnabled item = (FileStoreEnabled)itemType.getById(dc, itemId);
	final FileSet fileSet = item.hasFileSet() ? item.getFileSet() : null;
	Collection<FileSet> parents = null;
	try
	{
		parents = item.getParentFileSets();
	}
	catch (Throwable t)
	{}
	
	Platform platform = null;
	PlatformVariant variant = null;
	try
	{
		platform = item.getPlatform();
		variant = item.getVariant();
	}
	catch (Throwable t)
	{}
	
	// Load member file types
	List<DataFile> members = new LinkedList<DataFile>();
	Set<DataFileType> existing = new HashSet<DataFileType>();
	if (fileSet != null)
	{
		ItemQuery<FileSetMember> query = fileSet.getMembers();
		for (FileSetMember member : query.list(dc))
		{
			DataFileType dft = null;
			try
			{
				dft = member.getDataFileType();
				existing.add(dft);
			}
			catch (Throwable t)
			{}
			members.add(new DataFile(dft, member, null));
		}
	}
	int numMembers = members.size();
	if (parents != null && !parents.isEmpty())
	{
		for (FileSet pFileSet : parents)
		{
			try
			{
				FileStoreEnabled  parent = pFileSet.getItem();
				for (FileSetMember pMember : pFileSet.getMembers().list(dc))
				{
					DataFileType dft = null;
					try
					{
						dft = pMember.getDataFileType();
					}
					catch (Throwable t)
					{}
					members.add(new DataFile(dft, pMember, parent));
				}
			}
			catch (Throwable t)
			{}
		}
	}
	int numParents = members.size() - numMembers;
	

	// Load platform file types
	Map<DataFileType, PlatformFileType> platformFileTypes =
		new HashMap<DataFileType, PlatformFileType>();
	if (platform != null)
	{
		ItemQuery<PlatformFileType> query = platform.getFileTypes(variant, variant == null);
		for (PlatformFileType pft : query.list(dc))
		{
			DataFileType dft = null;
			try
			{
				dft = pft.getDataFileType();
				platformFileTypes.put(dft, pft);
				if (dft.getItemType() == itemType && !existing.contains(dft))
				{
					members.add(new DataFile(dft, null, null));
				}
			}
			catch (Throwable t)
			{}
		}
	}
	%>
	<base:page type="include">
	<base:body>
		<script language="JavaScript">
		</script>
			<%
			if (members.size() == 0)
			{
				%>
				<h4>Data files</h4>
				No files have been added to this item
				(or you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="datafiles" 
					title="<%="Data files (" + (numMembers + numParents) +")"%>"
					context="<%=cc%>">
				<tbl:table
					id="datafiles"
					clazz="itemlist"
					columns="all"
					>
				<tbl:columndef 
					id="type"
					title="Type"
				/>
				<tbl:columndef 
					id="file"
					title="File"
				/>
				<tbl:columndef 
					id="required"
					title="Required"
				/>
				<tbl:columndef 
					id="validation"
					title="Validation"
				/>
				<tbl:data>
					<tbl:columns>
					</tbl:columns>
					<tbl:rows>
					<%
					for (DataFile dataFile : members)
					{
						FileSetMember member = dataFile.member;
						DataFileType dft = dataFile.type;
						FileStoreEnabled parent = dataFile.parent;
						Boolean validFile = null;
						String validationMessage = "";
						boolean readFile = true;
						File file = null;
						boolean readDataFileType = true;
						if (member != null)
						{
							try
							{
								file = member.getFile();
							}
							catch (PermissionDeniedException ex)
							{
								readFile = false;
							}
							try
							{
								dft = member.getDataFileType();
							}
							catch (PermissionDeniedException ex)
							{
								readDataFileType = false;
							}
						}
						PlatformFileType pft = platformFileTypes.get(dft);
						boolean isRequired = pft == null ? false : pft.isRequired();
						boolean isPartOfPlatform = pft != null;
						String icon = null;
						if (member == null)
						{
							if (isRequired)
							{
								icon = "warning.gif";
								validationMessage = "Missing a required file";
							}
						}
						else 
						{
							validFile = member.isValid();
							if (Boolean.FALSE.equals(validFile))
							{
								validationMessage = HTML.encodeTags(member.getErrorMessage());
								icon = "error.gif";
							}
							else if (!isPartOfPlatform && platform != null)
							{
								icon = "warning.gif";
								validationMessage = "This file is not part of the <i>" + HTML.encodeTags(platform.getName()) + "</i> platform";
							}
							else if (Boolean.TRUE.equals(validFile))
							{
								validationMessage = "Ok";
								icon = "ok.gif";
							}
							else
							{
								validationMessage = "<i>- not validated -</i>";
							}
						}
						%>
						<tbl:row>
							<tbl:cell column="type"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=dft != null && dft.isRemoved()%>"
								/><%=Base.getLinkedName(ID, dft, !readDataFileType, true)%></tbl:cell>
							<tbl:cell column="file"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=file != null && file.isRemoved()%>"
								/>
								<%=Base.getLinkedFile(ID, file, !readFile, true, true, root)%>
								<%
								if (parent != null)
								{
									%>
									<i>(inherited from <%=Base.getLinkedName(ID, (Nameable)parent, false, true)%>)</i>
									<%
								}
								%>
							</tbl:cell>
							<tbl:cell column="required"><%=isRequired ? "yes" : "no" %></tbl:cell>
							<tbl:cell column="validation">
								<base:icon image="<%=icon%>" visible="<%=icon != null %>" /> 
								<%=validationMessage %>
							</tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				</base:section>
				<%
			}
			%>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
