<%-- $Id: edit_design.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ARRAYDESIGN;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ArrayDesign design = null;
	
	boolean deniedPlatform = false;
	Platform currentPlatform = null;
	PlatformVariant currentVariant = null;
	Platform defaultPlatform = null;
	PlatformVariant defaultVariant = null;
	
	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		try
		{
			defaultPlatform = (Platform)activeProject.getDefaultItem(dc, Project.Default.PLATFORM);
		}
		catch (PermissionDeniedException pdex)
		{}
		try
		{
			defaultVariant = (PlatformVariant)activeProject.getDefaultItem(dc, Project.Default.PLATFORM_VARIANT);
		}
		catch (PermissionDeniedException pdex)
		{}

	}
	if (itemId == 0)
	{
		title = "Create array design";
		cc.removeObject("item");
		int currentPlatformId = Values.getInt(cc.getRecent(Item.PLATFORM.name(), 0), 0);
		int currentVariantId = Values.getInt(cc.getRecent(Item.PLATFORMVARIANT.name(), 0), 0);
		try
		{
			if (currentPlatformId != 0) currentPlatform = Platform.getById(dc, currentPlatformId);
			if (currentVariantId != 0) currentVariant = PlatformVariant.getById(dc, currentVariantId);
		}
		catch (Throwable t)
		{}
		if (currentPlatform == null) currentPlatform = defaultPlatform;
		if (currentVariant == null) currentVariant = defaultVariant;
	}
	else
	{
		design = ArrayDesign.getById(dc, itemId);
		cc.setObject("item", design);
		title = "Edit array design -- " + HTML.encodeTags(design.getName());
		
		try
		{
			currentPlatform = design.getPlatform();
			currentVariant = design.getVariant();
		}
		catch (PermissionDeniedException ex)
		{
			deniedPlatform = true;
		}
		design.checkPermission(Permission.WRITE);
	}

	ItemQuery<Platform> platformQuery = Platform.getQuery();
	platformQuery.include(Include.REMOVED, Include.NOT_REMOVED);
	platformQuery.order(Orders.asc(Hql.property("name")));
	platformQuery.setCacheResult(true);
	ItemResultList<Platform> platforms = platformQuery.list(dc);

	ItemQuery<PlatformVariant> variantQuery = PlatformVariant.getQuery();
	variantQuery.include(Include.REMOVED, Include.NOT_REMOVED);
	variantQuery.order(Orders.asc(Hql.property("name")));
	variantQuery.setCacheResult(true);
	ItemResultList<PlatformVariant> variants = variantQuery.list(dc);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,platforms.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "ArrayDesign" tab
		function validateArrayDesign()
		{
			var frm = document.forms['design'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (!Numbers.isInteger(frm.numArrays.value))
			{
				alert("'" + frm.numArrays.value + "' is not a valid number");
				frm.numArrays.focus();
				return false;
			}
			else if (parseInt(frm.numArrays.value) <= 0)
			{
				alert("Number of arrays must be > 0");
				frm.numArrays.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['design'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				if (dataFilesLoaded)
				{
					Platforms.addDataFilesToForm(frames.datafiles, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var dataFilesLoaded = false;
		var platformChanged = false;
		function switchTab(tabControlId, tabId)
		{
			var frm = document.forms['design'];
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=design == null ? 0 : design.getId()%>);
					annotationsLoaded = true;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
				else if (tabId == 'datafiles' && (platformChanged || !dataFilesLoaded))
				{
					var platform = Platforms.getSelectedPlatform(frm.platform);
					var variant = Platforms.getSelectedVariant(frm.platform);
					Platforms.loadDataFilesFrame(frames.datafiles, '<%=ID%>', '<%=itemType.name()%>', <%=design == null ? 0 : design.getId()%>, platform == null ? 0 : platform.id, variant == null ? 0 : variant.id);
					dataFilesLoaded = true;
					platformChanged = false;
				}
			}
		}
		
		function getParents()
		{
			return new Array();
		}
		
		function platformOnChange()
		{
			platformChanged = true;
		}

		function init()
		{
			var frm = document.forms['design'];
			<%
			if (design == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initPlatforms(<%=currentPlatform == null ? 0 : currentPlatform.getId()%>, <%=currentVariant == null ? 0 : currentVariant.getId()%>);
		}
		
		function initPlatforms(platformId, variantId)
		{
			<%
			for (Platform p : platforms)
			{
				if (!p.isRemoved() || p.equals(currentPlatform))
				{
					RawDataType rdt = p.isFileOnly() ? null : p.getRawDataType();
					%>
					var p<%=p.getId()%> = new Platform(<%=p.getId()%>, '<%=HTML.javaScriptEncode(p.getExternalId())%>', '<%=HTML.javaScriptEncode(p.getName())%>', <%=p.isFileOnly()%>, '<%=rdt == null ? "" : rdt.getId()%>');
					<%
				}
			}
			for (PlatformVariant v : variants)
			{
				Platform p = v.getPlatform();
				if ((!v.isRemoved() || v.equals(currentVariant)) && (!p.isRemoved() || p.equals(currentPlatform)))
				{
					RawDataType rdt = v.isFileOnly() ? null : v.getRawDataType();
					%>
					var v<%=v.getId()%> = new Variant(p<%=p.getId()%>, <%=v.getId()%>, '<%=HTML.javaScriptEncode(v.getExternalId())%>', '<%=HTML.javaScriptEncode(v.getName())%>', <%=v.isFileOnly()%>, '<%=rdt == null ? "" : rdt.getId()%>');
					<%
				}
			}
			%>
			var frm = document.forms['design'];
			Platforms.populateList(frm.platform, platformId, variantId);
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="design" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom" active="<%=tabId%>" remember="<%=tabId == null && design != null%>" switch="switchTab">
		<t:tab id="info" title="Array design" validate="validateArrayDesign()" helpid="arraydesign.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(design == null ? Values.getString(cc.getPropertyValue("name"), "New array design") : design.getName())%>" 
					size="40" maxlength="<%=ArrayDesign.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Platform</td>
				<td>
					<select name="platform" onchange="platformOnChange()" class="required"
						<%=deniedPlatform ? "disabled" : "" %>>
					<%
					if (deniedPlatform)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">Arrays / slide</td>
				<td><input <%=requiredClazz%> type="text" name="numArrays" 
					value="<%=design == null ? Values.getString(cc.getPropertyValue("numArrays"), "1") : design.getNumArrays()%>" 
					size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(design == null ? cc.getPropertyValue("description") : design.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'design', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		<t:tab id="datafiles" title="Data files" helpid="datafiles.edit">
			<iframe name="datafiles" id="idDatafiles" src="../../common/datafiles/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
